## glaxnimate-0.5.80.tar.xz

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
# SPDX-License-Identifier: BSD-2-Clause

cmake_minimum_required (VERSION 3.16 FATAL_ERROR)
# cmake_policy(SET CMP0076 NEW)
cmake_policy(SET CMP0077 NEW)


project(Glaxnimate VERSION 0.5.80 LANGUAGES CXX)
include(FeatureSummary)

set(PROJECT_SLUG "glaxnimate")
set(LIB_NAME_CORE "${PROJECT_SLUG}_core")
set(LIB_NAME_GUI "${PROJECT_SLUG}_gui")
set(LIB_NAME_PYTHON "${PROJECT_SLUG}_python_lib")
set(LIB_NAME_DESKTOP "${PROJECT_SLUG}_desktop")
set(DATA_INSTALL "share/${PROJECT_SLUG}/${PROJECT_SLUG}")
set(PROJECT_ID "org.kde.glaxnimate")

set(PROJECT_HOMEPAGE_URL "https://glaxnimate.org/")
set(URL_DOCS "https://docs.glaxnimate.org/")
set(URL_ISSUES "https://bugs.kde.org/enter_bug.cgi?product=glaxnimate")
set(URL_DONATE "https://glaxnimate.org/donate/")

# You can use it to change the url used by `make docs`
set(DOCS_SITE_URL ${URL_DOCS} CACHE STRING "")
set(DOCS_REPO_URL "https://gitlab.com/mattbas/glaxnimate")
set(DOCS_CHAT_URL "https://t.me/Glaxnimate")

set(PROJECT_DESCRIPTION "Simple vector animation program")
set(PROJECT_MANINTAINER_NAME "Mattia Basaglia")
set(PROJECT_MANINTAINER_EMAIL "glanimate@mattbas.org")
set(PROJECT_MANINTAINER "${PROJECT_MANINTAINER_NAME} <${PROJECT_MANINTAINER_EMAIL}>")

option(MOBILE_UI "Build the mobile user interface" OFF)

add_definitions(-DTRANSLATION_DOMAIN=\"glaxnimate\")

if (ANDROID)
    set(MOBILE_UI ON)
endif()

if(MOBILE_UI)
    message(STATUS "Using mobile UI")
    add_compile_definitions(MOBILE_UI)
else()
    message(STATUS "Using desktop UI")
endif()

# CMake modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(misc)

# C++
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Git
set(VERSION_NAKED ${PROJECT_VERSION})
set(VERSION_SUFFIX "-git-" CACHE STRING "")

if (VERSION_SUFFIX STREQUAL "-git-" AND EXISTS ${CMAKE_SOURCE_DIR}/.git)
    # Probably a Git workspace; determine the revision.
    find_package(Git QUIET)
    if(GIT_FOUND)
        exec_program(${GIT_EXECUTABLE} ${CMAKE_SOURCE_DIR}
                ARGS "log -n 1 --pretty=format:\"%h\""
            OUTPUT_VARIABLE GIT_REVISION)
        message(STATUS "Git revision: ${GIT_REVISION}")
        set(PROJECT_VERSION "${PROJECT_VERSION}-git-${GIT_REVISION}")
    else()
        message(STATUS "Git revision could not be determined")
    endif()
elseif(VERSION_SUFFIX MATCHES "^\\..*")
    set(PROJECT_VERSION "${PROJECT_VERSION}${VERSION_SUFFIX}")
elseif(NOT VERSION_SUFFIX STREQUAL "")
    set(PROJECT_VERSION "${PROJECT_VERSION}+${VERSION_SUFFIX}")
endif()

message(STATUS "Building ${PROJECT_NAME} ${PROJECT_VERSION}")

# Snapcraft stuff here because we don't care if cmake fails on CI
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/deploy/snapcraft.in.yaml"
    "${CMAKE_CURRENT_BINARY_DIR}/snapcraft.yaml"
)
option(SNAP_IS_SUCH_A_PAIN "" OFF)
if ( SNAP_IS_SUCH_A_PAIN  )
    return()
endif()

# Fucking Windows being shit
if ( WIN32 AND MinGW )
    # Without this shit it gives a bunch of errors like this:
    # * referenced in section `.rdata' of * defined in discarded section `.gnu.linkonce.*`
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-lto")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -fno-lto")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fno-lto")
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION FALSE)
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
    set(CMAKE_ENABLE_EXPORTS TRUE)
endif()


# Python
if ( NOT MOBILE_UI )
    set(PYTHON_SCRIPTING_ENABLED ON)
else()
    set(PYTHON_SCRIPTING_ENABLED OFF)
endif()

if ( PYTHON_SCRIPTING_ENABLED )
    find_program(PYTHON_PIP pip3)
    if(NOT PYTHON_PIP)
        find_program(PYTHON_PIP pip)
    endif()

    find_package(Python3 COMPONENTS Interpreter Development REQUIRED)
    message(STATUS ${Python3_EXECUTABLE})
else()
    message(STATUS "Python Disabled")
endif()

# QT_MAJOR_VERSION is the common name in KDE apps and infrastructure.
# BUILD_WITH_QT6 is another thing on KDE infrastructure.
# However some third-party submodules use QT_VERSION_MAJOR so we need to set that too.
if (NOT DEFINED QT_MAJOR_VERSION)
    if(BUILD_WITH_QT6)
        set(QT_MAJOR_VERSION 6)
    else()
        set(QT_MAJOR_VERSION 5)
    endif()
endif()
set(QT_VERSION_MAJOR ${QT_MAJOR_VERSION})

# Qt
find_package(Qt${QT_MAJOR_VERSION} COMPONENTS Core Widgets Xml UiTools Concurrent Network Svg REQUIRED)
message(STATUS "Using Qt ${QT_MAJOR_VERSION}")

# KF
set(KF_DEP_VERSION "5.92.0")
find_package(ECM ${KF_DEP_VERSION} REQUIRED CONFIG)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_MODULE_PATH})
include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings)
if (QT_MAJOR_VERSION STREQUAL "6")
    include(ECMAddAndroidApk)
endif()
include(ECMAddAppIcon)

# TODO: The following definitons should be enabled
remove_definitions(
    -DQT_NO_CAST_FROM_ASCII
)

if (NOT DEFINED KF_MAJOR)
  set(KF_MAJOR ${QT_MAJOR_VERSION})
endif()

if (KF_MAJOR STREQUAL "6")
  set(KF_DEP_VERSION "5.240.0")
endif()

find_package(KF6BreezeIcons ${KF_DEP_VERSION} QUIET)

find_package(KF${KF_MAJOR} ${KF_DEP_VERSION}
    REQUIRED COMPONENTS
    I18n
    CoreAddons
    WidgetsAddons
    XmlGui
    Archive
    Completion
    IconThemes
    Config
)
if ( NOT ANDROID )
    find_package(KF${KF_MAJOR} ${KF_DEP_VERSION}
        REQUIRED COMPONENTS
        Crash
    )
endif()


set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Potrace
option(GLAXNIMATE_SYSTEM_POTRACE "Use the system potrace libarary" ON)
if (NOT GLAXNIMATE_SYSTEM_POTRACE)
    message(STATUS "Using bundled potrace")
    set(CMAKE_C_COMPILE_OBJECT ${CMAKE_CXX_COMPILE_OBJECT})
    add_subdirectory(external/potrace/)
    set(Potrace_LIBRARIES potrace)
    include_directories(external/potrace/src/)
else()
    find_package(Potrace REQUIRED)
endif()

# Debug flags
if(CMAKE_BUILD_TYPE STREQUAL "")
    set(CMAKE_BUILD_TYPE "Debug")
endif()
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wall -pedantic -Wextra")
message(STATUS "${CMAKE_BUILD_TYPE} build")

# sub projects and stuff

SET(BUILD_STATIC_LIBS ON CACHE BOOL "")
SET(BUILD_SHARED_LIBS OFF CACHE BOOL "")
add_definitions(-DQTCOLORWIDGETS_STATICALLY_LINKED)

add_subdirectory(external/QtAppSetup)

add_subdirectory(src bin)

set(QTCOLORWIDGETS_DESIGNER_PLUGIN ON)
add_subdirectory(external/Qt-Color-Widgets EXCLUDE_FROM_ALL)

set(ALL_SOURCE_DIRECTORIES src)
find_sources(ALL_SOURCES *.cpp *.hpp)

add_subdirectory(data ${DATA_INSTALL})

if(BUILD_TESTING)
    find_package(Qt${QT_MAJOR_VERSION}Test REQUIRED)
    message(STATUS "Tests enabled")
    add_subdirectory(test)
endif()

add_subdirectory(docs)

# Doxygen

set(DOXYGEN_FOUND ON)
find_package(Doxygen QUIET)
if(DOXYGEN_FOUND)
    create_doxygen_target(doxygen)
endif(DOXYGEN_FOUND)

# Release

add_custom_target(
    release_0
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/deploy/release_0.sh ${CMAKE_CURRENT_BINARY_DIR}/CMakeCache.txt
)
add_custom_target(
    release_1
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/deploy/release_1.sh ${CMAKE_CURRENT_BINARY_DIR}/CMakeCache.txt
)
add_custom_target(
    release_check
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/deploy/release_check.py ${VERSION_NAKED}
)

# Misc files
if (ANDROID)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/android/android/version.gradle.in ${CMAKE_BINARY_DIR}/version.gradle)
endif()
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/deploy/org.kde.glaxnimate.metainfo.xml DESTINATION share/metainfo)

ki18n_install(po)
file(CREATE_LINK ${CMAKE_CURRENT_BINARY_DIR}/locale ${CMAKE_CURRENT_BINARY_DIR}/share/locale SYMBOLIC)

# Packaging
# -- see https://gitlab.kitware.com/cmake/community/-/wikis/doc/cpack/PackageGenerators
set(CPACK_PACKAGE_CONTACT ${PROJECT_MANINTAINER})
set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY ${PROJECT_DESCRIPTION})

execute_process(COMMAND dpkg-architecture -qDEB_BUILD_ARCH OUTPUT_VARIABLE CPACK_DEBIAN_PACKAGE_ARCHITECTURE ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
set(CPACK_DEBIAN_PACKAGE_DEPENDS "libqt5xml5 (>= 5.10.0), libqt5widgets5 (>= 5.10.0), libpython3.10 (>= 3.10.0), zlib1g (>= 1:1.2.11), libpotrace0 (>= 1.16-2), libavformat58, libswscale5, qt5-image-formats-plugins, libarchive13")
set(CPACK_DEBIAN_PACKAGE_SECTION "graphics")
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE ${PROJECT_HOMEPAGE_URL})

set(CPACK_BUNDLE_NAME ${PROJECT_NAME})

set(CPACK_BUNDLE_ICON "${CMAKE_CURRENT_BINARY_DIR}/glaxnimate.icns")

include(CPack)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== data/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
# SPDX-License-Identifier: BSD-2-Clause

set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM 1)

if ( ANDROID )

    # The breeze-icons package approach is inspired by https://invent.kde.org/frameworks/kirigami/-/blob/kf5/KF5Kirigami2Macros.cmake
    include(CMakeParseArguments)
    include(ExternalProject)


    function(android_package_breeze_icons)
        set(_multiValueArgs ICONS)
        cmake_parse_arguments(ARG "" "" "${_multiValueArgs}" ${ARGN} )

        if(NOT ARG_ICONS)
            message(FATAL_ERROR "No ICONS argument given to android_package_breeze_icons")
        endif()

        function(_find_breeze_icon icon varName)
            #HACKY
            SET(path "")
            file(GLOB_RECURSE path ${_BREEZEICONS_DIR}/icons/*/48/${icon}.svg )

            #search in other sizes as well
            if (path STREQUAL "")
                file(GLOB_RECURSE path ${_BREEZEICONS_DIR}/icons/*/32/${icon}.svg )
                if (path STREQUAL "")
                    file(GLOB_RECURSE path ${_BREEZEICONS_DIR}/icons/*/22/${icon}.svg )
                    if (path STREQUAL "")
                        file(GLOB_RECURSE path ${_BREEZEICONS_DIR}/icons/*/16/${icon}.svg )
                    endif()
                endif()
            endif()
            if (path STREQUAL "")
                file(GLOB_RECURSE path ${_BREEZEICONS_DIR}/icons/*/symbolic/${icon}.svg )
            endif()
            if (path STREQUAL "")
                return()
            endif()

            list(LENGTH path _count_paths)
            if (_count_paths GREATER 1)
                message(WARNING "Found more than one version of '${icon}': ${path}")
            endif()
            list(GET path 0 path)
            get_filename_component(path "${path}" REALPATH)

            SET(${varName} ${path} PARENT_SCOPE)
        endfunction()

        if (BREEZEICONS_DIR AND NOT EXISTS ${BREEZEICONS_DIR})
            message(FATAL_ERROR "BREEZEICONS_DIR variable does not point to existing dir: \"${BREEZEICONS_DIR}\"")
        endif()

        set(_BREEZEICONS_DIR "${BREEZEICONS_DIR}")

        if(NOT _BREEZEICONS_DIR AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/icons/breeze-icons/icons")
            set(_BREEZEICONS_DIR "${CMAKE_CURRENT_SOURCE_DIR}/icons/breeze-icons")
        endif()

        #FIXME: this is a terrible hack
        if(NOT _BREEZEICONS_DIR)
            set(_BREEZEICONS_DIR "${CMAKE_BINARY_DIR}/breeze-icons/src/breeze-icons")

            # replacement for ExternalProject_Add not yet working
            # first time config?
            if (NOT EXISTS ${_BREEZEICONS_DIR})
                find_package(Git)
                execute_process(COMMAND ${GIT_EXECUTABLE} clone --depth 1 --branch kf5 https://invent.kde.org/frameworks/breeze-icons.git ${_BREEZEICONS_DIR})
            endif()

            # external projects are only pulled at make time, not configure time
            # so this is too late to work with the _find_breeze_icon() method
            # _find_breeze_icon() would need to be turned into a target/command
            if (FALSE)
            ExternalProject_Add(
                breeze-icons
                PREFIX breeze-icons
                GIT_REPOSITORY https://invent.kde.org/frameworks/breeze-icons.git
                CONFIGURE_COMMAND ""
                BUILD_COMMAND ""
                INSTALL_COMMAND ""
                LOG_DOWNLOAD ON
            )
            endif()
        endif()

        message (STATUS "Using ${_BREEZEICONS_DIR} as breeze dir")
        message (STATUS "Found external breeze icons:")
        foreach(_iconName ${ARG_ICONS})
            set(_iconPath "")
            _find_breeze_icon(${_iconName} _iconPath)
            message (STATUS ${_iconPath})
            if (EXISTS ${_iconPath})
                install(FILES ${_iconPath} DESTINATION ${DATA_INSTALL}/breeze-internal/icons RENAME ${_iconName}.svg)
            else()
                message (WARNING "${_iconName} not found")
            endif()
        endforeach()

        #generate an index.theme that qiconloader can understand
        file(WRITE ${CMAKE_BINARY_DIR}/index.theme "[Icon Theme]\nName=Breeze\nDirectories=icons\n[icons]\nSize=32\nType=Scalable")
        install(FILES ${CMAKE_BINARY_DIR}/index.theme DESTINATION ${DATA_INSTALL}/breeze-internal)
    endfunction()

    android_package_breeze_icons(ICONS
        telegram
        edit-cut
        edit-copy
        edit-paste
        edit-delete
        edit-undo
        edit-redo
        edit-select
        edit-node
        edit-clear-all
        document-new
        document-open
        document-save
        document-save-as
        document-import
        document-export
        document-properties
        keyframe-add
        keyframe-remove
        keyframe-record
        view-preview
        player-time
        fill-color
        object-stroke-style
        question
        draw-brush
        draw-bezier-curves
        draw-freehand
        draw-rectangle
        draw-ellipse
        draw-polygon-star
        draw-text
        shapes
        overflow-menu
        media-playback-start
        media-playlist-repeat
        go-first
        go-previous
        go-next
        go-last
        layer-lower
        layer-raise
        dialog-layers
        smiley-shape
    )

    #get_target_property(ASSETS_PATH ${PROJECT_SLUG}_apk assets)
    #file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/images DESTINATION ${ASSETS_PATH})
    #file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/templates DESTINATION ${ASSETS_PATH})
else()
    file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/lib/python-lottie/lib/lottie DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/lib/)
    install(DIRECTORY lib/python-lottie/lib/lottie DESTINATION ${DATA_INSTALL}/lib/)

    file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/emoji DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
    install(DIRECTORY emoji DESTINATION ${DATA_INSTALL})
endif()

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/palettes DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
install(DIRECTORY palettes DESTINATION ${DATA_INSTALL})

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/images DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
install(DIRECTORY images DESTINATION ${DATA_INSTALL})

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/templates DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
install(DIRECTORY templates DESTINATION ${DATA_INSTALL})

# Translation
set(ALL_SOURCE_DIRECTORIES ${CMAKE_SOURCE_DIR}/src)

# Desktop
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/glaxnimate.in.desktop ${CMAKE_CURRENT_BINARY_DIR}/glaxnimate.desktop)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/glaxnimate.desktop DESTINATION ${DATA_INSTALL})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/glaxnimate.desktop DESTINATION share/applications RENAME ${PROJECT_ID}.desktop)

# Misc
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/../AUTHORS.md ${CMAKE_CURRENT_BINARY_DIR}/AUTHORS.md COPYONLY)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/../AUTHORS.md DESTINATION ${DATA_INSTALL})

# Icon
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/logo/logo.svg ${CMAKE_CURRENT_BINARY_DIR}/images/${PROJECT_SLUG}.svg COPYONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/logo/file-icon.svg ${CMAKE_CURRENT_BINARY_DIR}/images/${PROJECT_SLUG}-file.svg COPYONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/images/${PROJECT_SLUG}.svg DESTINATION share/icons/hicolor/scalable/apps/ )
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/images/${PROJECT_SLUG}.svg DESTINATION share/icons/hicolor/scalable/apps/ RENAME ${PROJECT_ID}.svg )

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/images/${PROJECT_SLUG}.png
    COMMAND inkscape ${CMAKE_CURRENT_SOURCE_DIR}/logo/logo.svg -o ${CMAKE_CURRENT_SOURCE_DIR}/images/${PROJECT_SLUG}.png
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/logo/logo.svg
)
add_custom_target(
    logo_png
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/images/${PROJECT_SLUG}.png
)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/images/${PROJECT_SLUG}.png DESTINATION share/icons/hicolor/512x512/apps )
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/images/${PROJECT_SLUG}.svg DESTINATION share/icons/hicolor/512x512/apps/ RENAME ${PROJECT_ID}.png )

# Plugins
install(DIRECTORY plugins DESTINATION ${DATA_INSTALL})

function(plugin name)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/plugins/${name}/plugin.json ${CMAKE_CURRENT_BINARY_DIR}/plugins/${name}/plugin.json COPYONLY)
    foreach(file ${ARGN})
        configure_file(${CMAKE_CURRENT_SOURCE_DIR}/plugins/${name}/${file} ${CMAKE_CURRENT_BINARY_DIR}/plugins/${name}/${file} COPYONLY)
    endforeach()
endfunction()

plugin(
    Hello
    hello_world.py
)

plugin(
    ReplaceColor
    replace_color.py
    replace.ui
)

plugin(
    AnimatedRaster
    animated_raster.py
)

plugin(
    dotLottie
    dotlottie.py
    icon.svg
)

plugin(
    Synfig
    synfig.py
)

plugin(
    HueShift
    hue_shift.py
)


plugin(
    FrameByFrame
    create_frames.py
    create_frames.ui
)

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
# SPDX-License-Identifier: BSD-2-Clause

include_directories(${CMAKE_SOURCE_DIR}/external/QtAppSetup/src)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/core/)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/gui/)

if ( PYTHON_SCRIPTING_ENABLED )
    add_compile_definitions(PYTHON_SCRIPTING_ENABLED)
    add_subdirectory(python)
endif()

add_subdirectory(core)
add_subdirectory(gui)

if ( MOBILE_UI )
    add_subdirectory(android)
else()
    add_executable(${PROJECT_SLUG} WIN32)
    kde_target_enable_exceptions(${PROJECT_SLUG} PUBLIC)

    target_link_libraries(${PROJECT_SLUG} ${LIB_NAME_CORE} ${LIB_NAME_GUI} ${LIB_NAME_PYTHON} QtAppSetup)
    install(TARGETS ${PROJECT_SLUG} DESTINATION bin)

    ## Icon for Windows and OSX
    #file(GLOB ICONS_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/../data/images/logo.svg")
    ecm_add_app_icon(${PROJECT_SLUG} ICONS "${CMAKE_CURRENT_SOURCE_DIR}/../data/images/logo.svg") # icon name = variable name

    if (APPLE)
    # Apple app package
    set_target_properties(${PROJECT_SLUG} PROPERTIES
        MACOSX_BUNDLE_DISPLAY_NAME ${PROJECT_NAME}
        MACOSX_BUNDLE_BUNDLE_NAME ${PROJECT_NAME}
        MACOSX_BUNDLE_LONG_VERSION_STRING "${PROJECT_NAME} ${PROJECT_VERSION}"
        MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION}"
        MACOSX_BUNDLE_BUNDLE_VERSION "${RELEASE_SERVICE_VERSION}"
        MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.glaxnimate"
        MACOSX_BUNDLE_COPYRIGHT "2019-2024 The ${PROJECT_NAME} Authors")

    endif()

endif()

=== test/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
# SPDX-FileCopyrightText: 2023 Julius Künzel <jk.kdedev@smartlab.uber.space>
# SPDX-License-Identifier: BSD-2-Clause

include(ECMAddTests)

include_directories(
    ${CMAKE_SOURCE_DIR}/src
    # ${CMAKE_SOURCE_DIR}/external/QtAppSetup/src
    ${CMAKE_SOURCE_DIR}/src/core
)

set(TESTS_LINK_LIBS
    Qt${QT_MAJOR_VERSION}::Test
    Qt${QT_MAJOR_VERSION}::Widgets
    KF${KF_MAJOR}::I18n
    QtColorWidgets
    QtAppSetup
)

# Single source file tests, linking only to default libs

ecm_add_tests(
    test_bezier_solver.cpp
    test_riff.cpp
    LINK_LIBRARIES ${TESTS_LINK_LIBS}
)

# Single source file tests, linking to core lib additionally

ecm_add_tests(
    test_property.cpp
    test_trim_path.cpp
    test_trace.cpp
    test_aep_gradient_xml.cpp
    LINK_LIBRARIES ${TESTS_LINK_LIBS} ${LIB_NAME_CORE}
)

# Multi source files tests

ecm_add_test(
    test_bezier_length.cpp
    ../src/core/math/bezier/bezier.cpp
    ../src/core/math/bezier/point.cpp
    ../src/core/math/bezier/bezier_length.cpp
    TEST_NAME test_bezier_length
    LINK_LIBRARIES ${TESTS_LINK_LIBS}
)

ecm_add_test(
    test_keyframe_transition.cpp
    ../src/core/model/animation/keyframe_transition.cpp
    ../src/core/math/polynomial.cpp
    TEST_NAME test_keyframe_transition
    LINK_LIBRARIES ${TESTS_LINK_LIBS}
)

ecm_add_test(
    test_cos_parser.cpp
    ../src/core/io/aep/string_decoder.cpp
    TEST_NAME test_cos_parser
    LINK_LIBRARIES ${TESTS_LINK_LIBS}
)

=== external/Qt-Color-Widgets/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2013-2023 Mattia Basaglia <dev@dragon.best>
# SPDX-License-Identifier: BSD-2-Clause

cmake_minimum_required (VERSION 3.1...3.27 FATAL_ERROR)

if ( ${CMAKE_VERSION} VERSION_GREATER "3.12.0")
    cmake_policy(SET CMP0077 NEW)
endif()

set(COLORWIDGET_PROJECT_NAME QtColorWidgets)
project(${COLORWIDGET_PROJECT_NAME} CXX)


set (CMAKE_MODULE_PATH
  ${CMAKE_MODULE_PATH}
  ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules
  ${CMAKE_CURRENT_LIST_DIR})


include (CheckCXXCompilerFlag)

include (cmake/install.cmake)
include (cmake/versioning.cmake)


SET (${COLORWIDGET_PROJECT_NAME}_VERSION_MAJOR 2)
SET (${COLORWIDGET_PROJECT_NAME}_VERSION_MINOR 2)
SET (${COLORWIDGET_PROJECT_NAME}_VERSION_PATCH 0)
SET (${COLORWIDGET_PROJECT_NAME}_VERSION "${${COLORWIDGET_PROJECT_NAME}_VERSION_MAJOR}.${${COLORWIDGET_PROJECT_NAME}_VERSION_MINOR}.${${COLORWIDGET_PROJECT_NAME}_VERSION_PATCH}")


if(NOT QT_VERSION_MAJOR)
    set(QT_VERSION_MAJOR 5 CACHE STRING "Qt version to use (4, 5 or 6), defaults to 5")
endif()
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Core Widgets REQUIRED)

# These definitions do mostly match what with what KDE software uses
# See https://api.kde.org/ecm/kde-module/KDECompilerSettings.html
add_definitions(
    -DQT_NO_URL_CAST_FROM_STRING
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_FOREACH
    -DQT_NO_KEYWORDS
    -DQT_USE_QSTRINGBUILDER
    -DQT_NO_CAST_FROM_BYTEARRAY
    -DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT
)
if (NOT WIN32)
    add_definitions(-DQT_STRICT_ITERATORS)
endif()

# Auto generate moc files
set(CMAKE_AUTOMOC ON)
# Auto generate moc files
set(CMAKE_AUTOUIC ON)
# Auto generate moc files
set(CMAKE_AUTORCC ON)


if ( BUILD_SHARED_LIBS )
    option(BUILD_STATIC_LIBS "Build the static library" OFF)
else()
    option(BUILD_STATIC_LIBS "Build the static library" ON)
endif()

set (TARGET_NAME ${COLORWIDGET_PROJECT_NAME})
option(COLOR_WIDGETS_QT_SUFFIX "Append qt version to the target output files" OFF)
if ( COLOR_WIDGETS_QT_SUFFIX )
    set (TARGET_OUTPUT_SUFFIX "-Qt${QT_VERSION}${${COLORWIDGET_PROJECT_NAME}_VERSION_MAJOR}")
else()
    set (TARGET_OUTPUT_SUFFIX "")
endif()

set (INCLUDE_PREFIX "QtColorWidgets")
set (COLOR_WIDGETS_LIBRARY "${TARGET_NAME}")

if ( ${BUILD_STATIC_LIBS} )
    add_definitions(-DQTCOLORWIDGETS_STATICALLY_LINKED)
    add_library (${TARGET_NAME} STATIC "")
else()
    add_library (${TARGET_NAME} "")
endif()


set_target_properties(${TARGET_NAME}
  PROPERTIES
  EXPORT_NAME "${TARGET_NAME}${TARGET_OUTPUT_SUFFIX}")


set_target_properties (${TARGET_NAME}
    PROPERTIES
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED ON
    VERSION ${${COLORWIDGET_PROJECT_NAME}_VERSION}
    SOVERSION ${${COLORWIDGET_PROJECT_NAME}_VERSION_MAJOR}
    "INTERFACE_${COLORWIDGET_PROJECT_NAME}_MAJOR_VERSION" ${${COLORWIDGET_PROJECT_NAME}_VERSION_MAJOR}
    COMPATIBLE_INTERFACE_STRING "${COLORWIDGET_PROJECT_NAME}_MAJOR_VERSION"
    COMPILE_DEFINITIONS QTCOLORWIDGETS_LIBRARY
    OUTPUT_NAME "${TARGET_NAME}${TARGET_OUTPUT_SUFFIX}")

check_cxx_compiler_flag ("-Wall" Wall_FLAG_SUPPORTED)

if (Wall_FLAG_SUPPORTED)
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wall")
endif (Wall_FLAG_SUPPORTED)

check_cxx_compiler_flag ("-pedantic" pedantic_FLAG_SUPPORTED)

if (pedantic_FLAG_SUPPORTED)
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -pedantic")
endif (pedantic_FLAG_SUPPORTED)

check_cxx_compiler_flag ("-Wextra" Wextra_FLAG_SUPPORTED)

if (Wextra_FLAG_SUPPORTED)
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wextra")
endif (Wextra_FLAG_SUPPORTED)


set (EXPORT_HEADER "${INCLUDE_PREFIX}/colorwidgets_global.hpp")


generate_versioning_information (
    TARGET_NAME ${TARGET_NAME}
    EXPORT_HEADER ${EXPORT_HEADER}
    EXPORT_MACRO QCP_EXPORT
    VERSIONED_ENTITY ${COLORWIDGET_PROJECT_NAME}
    INCLUDE_PREFIX ${INCLUDE_PREFIX}
    COMPANY_NAME "Mattia Basaglia"
    COMPANY_COPYRIGHT "Mattia Basaglia Copyright (C) 2013-2020"
    FILE_DESCRIPTION "Color wheel widget and dialog for Qt${QT_VERSION}"
)


target_include_directories(${TARGET_NAME}
    PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
    PUBLIC
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
    $<INSTALL_INTERFACE:include>
)


add_subdirectory (${CMAKE_CURRENT_SOURCE_DIR}/include/${INCLUDE_PREFIX})
add_subdirectory (${CMAKE_CURRENT_SOURCE_DIR}/resources/${INCLUDE_PREFIX})
add_subdirectory (${CMAKE_CURRENT_SOURCE_DIR}/src/${INCLUDE_PREFIX})


target_link_libraries (${TARGET_NAME} PRIVATE Qt${QT_VERSION_MAJOR}::Widgets)


install_project (
    PROJECT_NAME ${COLORWIDGET_PROJECT_NAME}
    TARGET_NAME ${TARGET_NAME}
    TARGET_OUTPUT_SUFFIX "${TARGET_OUTPUT_SUFFIX}"
    EXPORT_HEADER ${EXPORT_HEADER}
    INCLUDE_PREFIX ${INCLUDE_PREFIX}
    HEADER_MATCHING_REGEX "^.*\.h$|^.*\.hpp$|^.*$"
    VERSION_HEADER ${CMAKE_CURRENT_BINARY_DIR}/${COLORWIDGET_PROJECT_NAME}_version.h
    NAMESPACE ""
)


add_subdirectory (gallery)

option(QTCOLORWIDGETS_DESIGNER_PLUGIN "Build QtDesigner plugin" ON)
if (${QTCOLORWIDGETS_DESIGNER_PLUGIN})
    find_package (Qt${QT_VERSION_MAJOR}Designer QUIET)
    if (Qt${QT_VERSION_MAJOR}Designer_FOUND)
        add_subdirectory (color_widgets_designer_plugin)
    endif(Qt${QT_VERSION_MAJOR}Designer_FOUND)
endif()

configure_file(Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
add_custom_target(
    ${COLORWIDGET_PROJECT_NAME}_docs
    COMMAND doxygen Doxyfile
    COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/gallery/*.png ${CMAKE_CURRENT_BINARY_DIR}/doxygen/html
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)

=== src/python/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
# SPDX-License-Identifier: BSD-2-Clause

set(SOURCES
    python.cpp
    miscdefs.cpp
)
add_library(${LIB_NAME_PYTHON} OBJECT ${SOURCES} embed.cpp)
kde_target_enable_exceptions(${LIB_NAME_PYTHON} PUBLIC)
#target_include_directories (${LIB_NAME_PYTHON} PUBLIC
        #${Python3_INCLUDE_DIRS}
        #${CMAKE_SOURCE_DIR}/external/QtAppSetup/external/pybind11/include
#)
target_link_libraries(${LIB_NAME_PYTHON} PUBLIC ${LIB_NAME_CORE} QtAppSetup)

pybind11_add_module(glaxnimate_python EXCLUDE_FROM_ALL ${SOURCES} module.cpp)
set_target_properties(
    glaxnimate_python PROPERTIES
    OUTPUT_NAME ${PROJECT_SLUG}
    LIBRARY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/build/lib"
)
target_link_libraries(glaxnimate_python PUBLIC ${LIB_NAME_CORE} QtAppSetup)
add_custom_command(TARGET glaxnimate_python PRE_BUILD COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_CURRENT_BINARY_DIR}/build/lib")


get_target_property(pain1 glaxnimate_python PREFIX)
get_target_property(pain2 glaxnimate_python OUTPUT_NAME)
get_target_property(pain3 glaxnimate_python SUFFIX)
set(MODULE_LIB_NAME "${pain1}${pain2}${pain3}")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/README.md ${CMAKE_CURRENT_BINARY_DIR}/README.md COPYONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/setup.in.py ${CMAKE_CURRENT_BINARY_DIR}/setup.py)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/MANIFEST.in.in ${CMAKE_CURRENT_BINARY_DIR}/MANIFEST.in)


if(PYTHON_PIP)
    add_custom_target(
        glaxnimate_python_depends_install
        COMMAND ${PYTHON_PIP} install -r ${CMAKE_CURRENT_SOURCE_DIR}/build-requirements.txt
    )
endif()


if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
    set(WHEEL_CMD "--plat-name" "manylinux1_x86_64")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Windows")
    set(WHEEL_CMD "--plat-name" "win32")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
    execute_process(
        COMMAND echo "from distutils.util import get_platform; print(get_platform().replace('.', '_').replace('-', '_').replace('x_11_x', 'x_11_0_x'))"
        COMMAND python3
        OUTPUT_VARIABLE MAC_PY_PLATFORM_TAG
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    set(WHEEL_CMD "--plat-name" ${MAC_PY_PLATFORM_TAG})
else()
    set(WHEEL_CMD)
endif()

add_custom_target(
    glaxnimate_python_wheel
    COMMAND rm -f ./dist/*.whl
    COMMAND ./setup.py build bdist_wheel ${WHEEL_CMD}
    #DEPENDS glaxnimate_python
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)

add_custom_target(
    glaxnimate_python_upload
    COMMAND ${Python3_EXECUTABLE} -m twine upload dist/*.whl --verbose
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)

=== external/Qt-Color-Widgets/color_widgets_designer_plugin/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2013-2023 Mattia Basaglia <dev@dragon.best>
# SPDX-License-Identifier: BSD-2-Clause

cmake_minimum_required (VERSION 3.1...3.27 FATAL_ERROR)

project(QtColorWidgetsPlugin CXX)


set (CMAKE_MODULE_PATH
  ${CMAKE_MODULE_PATH}
  ${CMAKE_SOURCE_DIR}/cmake/modules
  ${CMAKE_CURRENT_LIST_DIR}/..)


include (CheckCXXCompilerFlag)

include (../cmake/versioning.cmake)


SET (${PROJECT_NAME}_VERSION_MAJOR 2)
SET (${PROJECT_NAME}_VERSION_MINOR 2)
SET (${PROJECT_NAME}_VERSION_PATCH 0)
SET (${PROJECT_NAME}_VERSION "${${PROJECT_NAME}_VERSION_MAJOR}.${${PROJECT_NAME}_VERSION_MINOR}.${${PROJECT_NAME}_VERSION_PATCH}")


find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Designer REQUIRED)

# Auto generate moc files
set(CMAKE_AUTOMOC ON)
# Auto generate moc files
set(CMAKE_AUTOUIC ON)
# Auto generate moc files
set(CMAKE_AUTORCC ON)

check_cxx_compiler_flag ("-Wall" Wall_FLAG_SUPPORTED)

if (Wall_FLAG_SUPPORTED)
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wall")
endif (Wall_FLAG_SUPPORTED)

check_cxx_compiler_flag ("-pedantic" pedantic_FLAG_SUPPORTED)

if (pedantic_FLAG_SUPPORTED)
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -pedantic")
endif (pedantic_FLAG_SUPPORTED)

check_cxx_compiler_flag ("-Wextra" Wextra_FLAG_SUPPORTED)

if (Wextra_FLAG_SUPPORTED)
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wextra")
endif (Wextra_FLAG_SUPPORTED)

# Library
set (TARGET_NAME ${PROJECT_NAME})
set (TARGET_OUTPUT_SUFFIX "-Qt${QT_VERSION}${${PROJECT_NAME}_VERSION_MAJOR}")

add_library (${TARGET_NAME} SHARED "")
set_target_properties(${TARGET_NAME}
  PROPERTIES
  EXPORT_NAME "${TARGET_NAME}${TARGET_OUTPUT_SUFFIX}")

set_target_properties (${TARGET_NAME}
  PROPERTIES
  CXX_STANDARD 11
  CXX_STANDARD_REQUIRED ON
  VERSION ${${PROJECT_NAME}_VERSION}
  SOVERSION ${${PROJECT_NAME}_VERSION_MAJOR}
  "INTERFACE_${PROJECT_NAME}_MAJOR_VERSION" ${${PROJECT_NAME}_VERSION_MAJOR}
  COMPATIBLE_INTERFACE_STRING "${PROJECT_NAME}_MAJOR_VERSION"
  OUTPUT_NAME "${TARGET_NAME}${TARGET_OUTPUT_SUFFIX}")


target_link_libraries(${TARGET_NAME}
  PRIVATE
  ${COLOR_WIDGETS_LIBRARY}
  Qt${QT_VERSION_MAJOR}::Designer
  )


# Sources
set(SOURCES
  color_preview_plugin.cpp
  color_wheel_plugin.cpp
  color_widget_plugin_collection.cpp
  gradient_slider_plugin.cpp
  hue_slider_plugin.cpp
  color_selector_plugin.cpp
  color_list_plugin.cpp
  swatch_plugin.cpp
  color_palette_widget_plugin.cpp
  color_2d_slider_plugin.cpp
  color_line_edit_plugin.cpp
  gradient_editor_plugin.cpp
  # add new sources above this line
  )

foreach (SOURCE IN LISTS SOURCES)
  target_sources (${TARGET_NAME}
    PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/${SOURCE}>)
endforeach (SOURCE IN SOURCES)

set(HEADERS
  color_preview_plugin.hpp
  color_wheel_plugin.hpp
  color_widget_plugin_collection.hpp
  gradient_slider_plugin.hpp
  hue_slider_plugin.hpp
  color_selector_plugin.hpp
  color_list_plugin.hpp
  swatch_plugin.hpp
  color_palette_widget_plugin.hpp
  color_2d_slider_plugin.hpp
  color_line_edit_plugin.hpp
  gradient_editor_plugin.hpp
  # add new headers above this line
  )

foreach (HEADER IN LISTS HEADERS)
  target_sources (${TARGET_NAME}
    PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/${HEADER}>)
endforeach (HEADER IN HEADERS)


# install
get_target_property (QT_QMAKE_EXECUTABLE
  Qt${QT_VERSION_MAJOR}::qmake LOCATION)

execute_process (
  COMMAND ${QT_QMAKE_EXECUTABLE} -query QT_INSTALL_PLUGINS
  OUTPUT_VARIABLE QT_INSTALL_PLUGINS
  OUTPUT_STRIP_TRAILING_WHITESPACE)

# install(TARGETS ${COLOR_WIDGETS_PLUGIN} DESTINATION ${QT_INSTALL_PLUGINS}/designer OPTIONAL)

execute_process (
  COMMAND ${QT_QMAKE_EXECUTABLE} -query QT_INSTALL_LIBS
  OUTPUT_VARIABLE QT_INSTALL_LIBS
  OUTPUT_STRIP_TRAILING_WHITESPACE)

# install(TARGETS ${COLOR_WIDGETS_PLUGIN} DESTINATION ${QT_INSTALL_LIBS}/qtcreator/plugins OPTIONAL)

add_custom_target(${TARGET_NAME}_install
    COMMAND cp $<TARGET_FILE:${TARGET_NAME}> ${QT_INSTALL_PLUGINS}/designer
    COMMAND cp $<TARGET_FILE:${TARGET_NAME}> ${QT_INSTALL_LIBS}/qtcreator/plugins
    DEPENDS ${TARGET_NAME}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

=== external/Qt-Color-Widgets/resources/QtColorWidgets/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2013-2023 Mattia Basaglia <dev@dragon.best>
# SPDX-License-Identifier: BSD-2-Clause

set (SOURCES
  alphaback.png
  color_widgets.qrc
  )

file(RELATIVE_PATH
  PREFIX
  ${PROJECT_SOURCE_DIR}
  ${CMAKE_CURRENT_LIST_DIR})


foreach (SOURCE IN LISTS SOURCES)
  target_sources (${TARGET_NAME}
    PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/${SOURCE}>)
endforeach (SOURCE IN SOURCES)

=== external/Qt-Color-Widgets/src/QtColorWidgets/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2013-2023 Mattia Basaglia <dev@dragon.best>
# SPDX-License-Identifier: BSD-2-Clause

set (SOURCES
abstract_widget_list.cpp
bound_color_selector.cpp
color_2d_slider.cpp
color_delegate.cpp
color_dialog.cpp
color_dialog.ui
color_line_edit.cpp
color_list_widget.cpp
color_names.cpp
color_palette.cpp
color_palette_model.cpp
color_palette_widget.cpp
color_palette_widget.ui
color_preview.cpp
color_selector.cpp
color_utils.cpp
color_wheel.cpp
gradient_slider.cpp
hue_slider.cpp
swatch.cpp
gradient_editor.cpp
harmony_color_wheel.cpp
gradient_list_model.cpp
)

file(RELATIVE_PATH
  PREFIX
  ${PROJECT_SOURCE_DIR}
  ${CMAKE_CURRENT_LIST_DIR})


foreach (SOURCE IN LISTS SOURCES)
  target_sources (${TARGET_NAME}
    PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/${SOURCE}>)
endforeach (SOURCE IN SOURCES)

=== deploy/PKGBUILD ===
# Maintainer: Sythelux Rikd <dersyth@gmail.com>
# Maintainer: Mattia Basaglia <glax@dragon.best>
_corpname=glaxnimate
_pkgname='glaxnimate'
pkgname="$_pkgname"
_git_branch="release"
pkgver=0.5.0
pkgrel=1
pkgdesc="Simple vector animation program."
url="https://glaxnimate.org/"
license=('GPL3')
arch=('x86_64' 'i686' 'armv7h' 'aarch64' 'riscv32' 'riscv64')
makedepends=('git' 'cmake' 'make' 'gcc' 'qt6-declarative')
depends=('python' 'zlib' 'hicolor-icon-theme' 'potrace' 'ffmpeg' 'libarchive' 'qt6-tools' 'qt6-base' 'qt6-imageformats' 'qt6-svg')
provides=("$_pkgname")
conflicts=("$_pkgname")
source=(
    "$_pkgname::git+https://gitlab.com/mattbas/$_pkgname/#branch=$_git_branch"
)
sha256sums=('SKIP')

prepare() {
    cd "$_pkgname/"

    # Provide git submodules
    git submodule init
    git submodule update --init --recursive
}

pkgver() {
    cd "$srcdir/$_pkgname/"
    git describe --tags | tr - _
}

build() {
    cd "$srcdir/$_pkgname/"
    mkdir -p build
    cd build
    cmake ".." -DCMAKE_INSTALL_PREFIX=/usr
    # For more build jobs:
    # echo 'MAKEFLAGS="-j4"' >>/etc/makepkg.conf
    # (or ~/.makepkg.conf)
    make
    make translations VERBOSE=1
}

package() {
    cd "$srcdir/$_pkgname/build"
    make install DESTDIR=$pkgdir >/dev/null
}
